
<?= $element->renderSubmenu('/2-lekce-podminky'); ?>

<h1 class="mainTitle"><?= $template->title; ?></h1>

<p>
	<b>Podmínky</b> nám umožnují, aby se provedla jedna nebo druhá část příkazů, a to pravě na základě splnění/nesplnění podmínky.<br>
	Podmínky nám větví program - <b>vytváříme větve programu</b>.<br>
	Podmínka má pouze 2 možnosti - <b>pravda</b> nebo <b>lež</b>.
</p>

<ul>
	<li>podmínku zapíšeme pomocí klíčovho slova <b class="text-pink-dark">if</b></li>
	<li>za klíčovým slovíčkem následuje závorka, ve které je výraz pro vyhodnocení</li>
	<li>za touto podmínkou se potom píšou chlupaté závorky <b class="text-pink-dark">{</b> a <b class="text-pink-dark">}</b></li>
</ul>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="font-normal">podmínka</span>) <span class="text-pink-dark">{</span>
    <span class="text-pink-dark">}</span>
?&gt;
</pre>

<h2 class="mainTitle" id="operatory">Operátory</h2>
<h3>Matematické operátory</h3>

<p>Při vyhodnocování, zda je podmínka pravda nebo lež používáme tyto operátory:</p>

<table>
	<thead>
		<tr>
			<th class="w-32 text-left">Symbol</th>
			<th class="w-48 text-left">Příklad</th>
			<th class="text-left">Popis</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><b class="text-pink-dark">==</b>, <b class="text-pink-dark">!=</b></td>
			<td><b>1 <span class="text-pink-dark">==</span> 1</b>, <b>1 <span class="text-pink-dark">!=</span> 1</b></td>
			<td>je rovno, není rovno</td>
		</tr>
		<tr>
			<td><b class="text-pink-dark">&lt;</b>, <b class="text-pink-dark">></b></td>
			<td><b>10 <span class="text-pink-dark">&lt;</span> 5</b>, <b>10 <span class="text-pink-dark">></span> 5</b></td>
			<td>menší než, větší než</td>
		</tr>
		<tr>
			<td><b class="text-pink-dark">&lt;=</b>, <b class="text-pink-dark">>=</b></td>
			<td><b>8 <span class="text-pink-dark">&lt;=</span> 3</b>, <b>8 <span class="text-pink-dark">>=</span> 3</b></td>
			<td>menší nebo rovno než, větší nebo rovno než</td>
		</tr>
		<tr>
			<td><b class="text-pink-dark">===</b></td>
			<td><b>8 <span class="text-pink-dark">===</span> 8</b></td>
			<td>porovná hodnoty a také zda se jedná o stejný datový typ (string == string nebo integer == integer)</td>
		</tr>
	</tbody>
</table>

<p><b>Ukázka</b></p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="font-normal">hodnota/proměnná</span> <span class="php__obj">operátor</span> <span class="font-normal">hodnota/proměnná</span>) {
    }
?&gt;
</pre>

<h3>Logické operátory</h3>

<p>
	V rámci jednoho <b>if</b>u můžeme chtít porovnávat i více podmínek. Pro tyto účely používáme logické operátory.
</p>

<table>
	<thead>
		<tr>
			<th class="w-32 text-left">Symbol</th>
			<th class="w-64 text-left">Příklad</th>
			<th class="text-left">Popis</th>
		</tr>
	</thead>
	<tbody>
		<tr>
			<td><b class="text-pink-dark">&&</b></td>
			<td><b>podmínka 1 <span class="text-pink-dark">&&</span> podmínka 2</b></td>
			<td>celý výraz je pravdivý pokud je pravda podmínka 1 <b>a zároveň</b> je pravda i podmínka 2</td>
		</tr>
		<tr>
			<td><b class="text-pink-dark">||</b></td>
			<td><b>podmínka 1 <span class="text-pink-dark">||</span> podmínka 2</b></td>
			<td>celý výraz je pravdivý pokud je pravda podmínka 1 <b>nebo</b> je pravda podmínka 2</td>
		</tr>
	</tbody>
</table>

<p><b>Ukázka</b></p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="font-normal">podmínka</span> <span class="php__obj">logický operátor</span> <span class="font-normal">podmínka</span>) {
    }
?&gt;
</pre>

<h3>Tip pro pokročilejší</h3>

<p>Pokud použijete tento výraz (příklad níže) a proměnná obsahuje nějakou hodnotu (kromě hodnoty <b>FALSE</b> nebo <b>NULL</b>), tak výraz bude vždy <b>pravda</b>.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="php__var">$promenna</span>) {
    }
?&gt;
</pre>


<p>Naopak také můžeme pomocí obecné <b>negace</b> <b class="text-pink-dark">!</b> zjistit zda je podmínka lež.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="php__var"><span class="text-pink-dark">!</span>$promenna</span>) {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">$promenna bude prázdná</span></span>
    }

    <span class="php__syntax">if</span> (<span class="text-pink-dark">!</span>(<span class="font-normal">podmínka</span>)) {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">podmínka nebude pravda</span></span>
    }
?&gt;
</pre>

<h2 class="mainTitle" id="else">Větvení - else</h2>

<p>Jak jsme si řekli výše, pomocí podmínek vytváříme větve. Zatím jsme si ukázali jenom jednu. Pomocí klíčového slovíčka <b class="text-pink-dark">else</b> vytvoříme další.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="font-normal">podmínka</span>) {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">podmínka bude pravda</span></span>
    } <span class="php__syntax">else</span> {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">podmínka nebude pravda</span></span>
    }
?&gt;
</pre>

<p>Když potřebuje více větví, přidáme za <b>else</b> další <b>if</b>.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="font-normal">podmínka 1</span>) {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">podmínka 1 bude pravda</span></span>
    } <span class="php__syntax">else if</span> (<span class="font-normal">podmínka 2</span>) {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">podmínka 2 bude pravda</span></span>
    } <span class="php__syntax">else</span> {
        <span class="php__comment">// tato větev se provede pouze tehdy, pokud <span class="text-black">podmínka 1 a podmínka 2 nebude pravda</span></span>
    }
?&gt;
</pre>

<p>Také samozřejmě můžeme vkládat podmínku do podmínky.</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="font-normal">podmínka 1</span>) {
        <span class="php__syntax">if</span> (<span class="font-normal">podmínka 2</span>) {
            <span class="php__comment">// příkazy se provedou, když je <span class="text-black">podmínka 1 i podmínka 2 pravda</span></span>
        } <span class="php__syntax">else</span> {
            <span class="php__comment">// příkazy se provedou, pouze když je <span class="text-black">podmínka 1 pravda a podmínka 2 lež</span></span>
        }
    }
?&gt;
</pre>

<h2 class="mainTitle" id="switch">Switch</h2>
<p>
	Konstrukce <b class="text-pink-dark">switch</b> je velmi podobná podmínkám a vytváření větví pomocí <b>if-else</b>.<br>
	<b>Switch</b> využijeme tam, kde jednu podmínku porovnáváme na více hodnot. Například takto:
</p>

<pre class="php">
&lt;?php
    <span class="php__var">$vysledek</span> = <span class="php__syntax">NULL</span>;
    <span class="php__syntax">switch</span> (<span class="php__var">$operace</span>) {
        <span class="php__syntax">case</span> <span class="php__str">'+'</span>:
            <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> + <span class="php__var">$b</span>;
            <span class="php__syntax">break</span>;
         <span class="php__syntax">case</span> <span class="php__str">'-'</span>:
            <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> - <span class="php__var">$b</span>;
            <span class="php__syntax">break</span>;
        <span class="php__syntax">case</span> <span class="php__str">'*'</span>:
            <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> * <span class="php__var">$b</span>;
            <span class="php__syntax">break</span>;
        <span class="php__syntax">case</span> <span class="php__str">'/'</span>:
            <span class="php__var">echo</span> <span class="php__str">"Nulou nelze dělit"</span>;
            <span class="php__syntax">if</span> (<span class="php__var">$b</span> != <span class="php__num">0</span>) {
                <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> / <span class="php__var">$b</span>;
            }
            <span class="php__syntax">break</span>;
        <span class="php__syntax">default</span>:
            <span class="php__syntax">echo</span> <span class="php__str">"Neznámá operace"</span>;
    }

    <span class="php__syntax">if</span> (<span class="php__var">$vysledek</span> != <span class="php__syntax">NULL</span>) {
        <span class="php__syntax">echo</span> <span class="php__str">"Výsledek operace je: <span class="php__var">{$vysledek}</span>"</span>;
    }
?&gt;
</pre>

<p><span class="link" data-open-code="switch-simple">Ukázat</span> stejnou konstrukci pomocí podmínek <b>if</b>.</p>

<div class="hidden" data-open-code-id="switch-simple">
	<pre class="php">
&lt;?php
    <span class="php__var">$vysledek</span> = <span class="php__syntax">NULL</span>;
    <span class="php__syntax">if</span> (<span class="php__var">$operace</span> == <span class="php__str">'+'</span>) {
        <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> + <span class="php__var">$b</span>;
    } <span class="php__syntax">else if</span> (<span class="php__var">$operace</span> == <span class="php__str">'-'</span>) {
        <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> - <span class="php__var">$b</span>;
    } <span class="php__syntax">else if</span> (<span class="php__var">$operace</span> == <span class="php__str">'*'</span>) {
        <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> * <span class="php__var">$b</span>;
    } <span class="php__syntax">else if</span> (<span class="php__var">$operace</span> == <span class="php__str">'/'</span>) {
        <span class="php__var">echo</span> <span class="php__str">"Nulou nelze dělit"</span>;
        <span class="php__syntax">if</span> (<span class="php__var">$b</span> != <span class="php__num">0</span>) {
            <span class="php__var">$vysledek</span> = <span class="php__var">$a</span> / <span class="php__var">$b</span>;
        }
    } <span class="php__syntax">else</span> {
        <span class="php__syntax">echo</span> <span class="php__str">"Neznámá operace"</span>;
    }

    <span class="php__syntax">if</span> (<span class="php__var">$vysledek</span> != <span class="php__syntax">NULL</span>) {
        <span class="php__syntax">echo</span> <span class="php__str">"Výsledek operace je: <span class="php__var">{$vysledek}</span>"</span>;
    }
?&gt;
	</pre>
</div>

<p>
	Když se podíváme na kód výše, tak hned za <b>switch</b> vkládáme proměnnou, kterou chceme porovnávat. Za ní následují <b>chlupaté závorky</b>.
</p>
<p>
	Poté následuje konstrukce <b class="text-pink-dark">case</b>, která nám vytváří větvi. Respektive porovnává, zda se proměnná rovná výrazu, který napíšeme hned za konstrukci <b>case</b>.
	Za tímto výrazem následuje <b class="text-pink-dark">:</b> (dvojtečka). Za ní již následují příkazy, které chceme provést.
</p>
<p>
	Až budeme chtít ukončit naši "větev", napíšeme klíčové slovíčko <b class="text-pink-dark">break</b>. Tím dojde k ukončení konstrukce <b>switch</b> a program se posune za chlupatou závorku switch. Pokud toto slovíčko nenapíšeme, program pokračuje dále a proměnnou porovnává i na další hodnoty.
	To ale rozhodně nechceme.
</p>
<p>
	Jako poslední vidíme <b class="text-pink-dark">default</b>. Tato větev se provede ve chvíli, kdy proměnná neodpovídá žádné hodnotě v <b>case</b>.
	Tato "větev" je nepovinná, a protože je poslední, nemusíme již psát <b>break</b>.
</p>

<p>Někdy potřebujeme zjistit porovnání i na více hodnot. To provedeme následovně:</p>

<pre class="php">
&lt;?php
    <span class="php__syntax">switch</span> (<span class="php__var">$barva</span>) {
        <span class="php__syntax">case</span> <span class="php__str">'cervena'</span>:
        <span class="php__syntax">case</span> <span class="php__str">'červená'</span>:
            <span class="php__var">$vysledek</span> = <span class="php__str">"Barva je červená."</span>;
            <span class="php__syntax">break</span>;
         <span class="php__syntax">case</span> <span class="php__str">'modra'</span>:
         <span class="php__syntax">case</span> <span class="php__str">'modrá'</span>:
            <span class="php__var">$vysledek</span> = <span class="php__str">"Barva je modrá."</span>;
            <span class="php__syntax">break</span>;
        <span class="php__syntax">default</span>:
            <span class="php__var">$vysledek</span> = <span class="php__str">"Barva není červená ani modrá"</span>;
    }

    <span class="php__syntax">echo</span> <span class="php__var">$vysledek</span>;
?&gt;
</pre>

<p><span class="link" data-open-code="switch-multi">Ukázat</span> stejnou konstrukci pomocí podmínek <b>if</b>.</p>

<div class="hidden" data-open-code-id="switch-multi">
	<pre class="php">
&lt;?php
    <span class="php__syntax">if</span> (<span class="php__var">$barva</span> == <span class="php__str">'cervena'</span> <span class="php__obj">||</span> <span class="php__var">$barva</span> == <span class="php__str">'červená'</span>) {
        <span class="php__var">$vysledek</span> = <span class="php__str">"Barva je červená."</span>;
    } <span class="php__syntax">else if</span> (<span class="php__var">$barva</span> == <span class="php__str">'modra'</span> <span class="php__obj">||</span> <span class="php__var">$barva</span> == <span class="php__str">'modrá'</span>) {
        <span class="php__var">$vysledek</span> = <span class="php__str">"Barva je modrá."</span>;
    } <span class="php__syntax">else</span> {
        <span class="php__var">$vysledek</span> = <span class="php__str">"Barva není červená ani modrá"</span>;
    }

    <span class="php__syntax">echo</span> <span class="php__var">$vysledek</span>;
?&gt;
	</pre>
</div>
